#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>

#define ROOT     0
#define DATASIZE 1024

int main( int argc, char** argv ) {

    int size, rank;
    int *data, *results, *local_data;
    int i, j, k;

    MPI_Init( &argc, &argv );
    MPI_Comm_size( MPI_COMM_WORLD, &size );
    MPI_Comm_rank( MPI_COMM_WORLD, &rank );

    /* Hello ! */

    fprintf( stderr, "I am rank %d in %d\n", rank, size );

    /* on prpare le tableau de donnes */

    if( ROOT == rank ) {
        data = (int *) malloc( DATASIZE * sizeof( int ) );
        for( i = 0 ; i < DATASIZE ; ++i ) {
            data[i] = i;
        }
    }

    local_data = (int *) malloc( DATASIZE / size * sizeof( int ) );

    /* distribution du travail */

    MPI_Scatter( data, DATASIZE / size, MPI_INT, 
                 local_data, DATASIZE / size, MPI_INT,
                 ROOT, MPI_COMM_WORLD );

    /* au boulot ! */
    
    for( i = 0 ; i < DATASIZE / size ; ++i ) {
        for( j = 0 ; j < DATASIZE / size ; ++j ) {
            for( k = 0 ; k < DATASIZE / size ; ++k ) {
                local_data[i] += k*j;
            }
        }
    }
    
    /* rcupration du rsultat */

    if( ROOT == rank ) {
        results = (int *) malloc( DATASIZE * sizeof( int ) );
    }

    MPI_Gather( local_data, DATASIZE / size, MPI_INT, 
                results, DATASIZE / size, MPI_INT,
                ROOT, MPI_COMM_WORLD );

    /* finalisation */
    
    if( ROOT == rank ) {
        free( data );
        free( results );
    }
    free( local_data );

    MPI_Finalize();
    return EXIT_SUCCESS;

}
