#include <stdio.h>
#include <stdlib.h>

#define VECSIZE 16

int rand_range( int min, int max ){
    return min + (int) ( max - min + 1 )*((double)rand()/RAND_MAX);
}

/* Make sure this function is not vectorized */

__attribute__((optimize("no-tree-vectorize")))
void initmatrix( double * restrict matrix ){
    int i;
    for( i = 0 ; i < VECSIZE*VECSIZE ; i++ ) {
        matrix[i] = (double)i;
    }
}


int main( int argc, char** argv ){
    double matrix[VECSIZE*VECSIZE];
    double vector[VECSIZE];
    int i;

    initmatrix( matrix );

    /* This is the interesting loop */
    
    for( i = 1 ; i < VECSIZE ; i++ ) {
        vector[i] = rand_range( 1, 4) * ( matrix[i*VECSIZE] + matrix[(i+rand_range( 0, VECSIZE ))*VECSIZE] );
    }

    /* Necessary because with -O3, gcc detects that nothing is done */

    /*    for( i = 0 ; i < VECSIZE ; i++ ) {
        printf( "%.2lf ", vector[i] );
    }
    printf( "\n" );     */

   return EXIT_SUCCESS;
}
